package require nx
package provide MB 0.1


namespace eval ::MB {

##########################################################
# class ModelBuilder
##########################################################
nx::Class create ModelBuilder {
  
  :property -accessor public {viewMMEcore "ecoreModels/VIEW.ecore"}
  :property -accessor public {traceMMEcore "ecoreModels/TRACE.ecore"}
  :property -accessor public {umlMMEcore "ecoreModels/UML.ecore"}  
  :property -accessor public {interObjectTransformer "modelBuilder/TraceView2UML.qvto"}
  :property -accessor public {qvtoStandAlone "modelBuilder/qvto-app-0.1-SNAPSHOT.jar"}
  :property -accessor public {viewModel ""}
  :property -accessor public {traceModel ""}

  # trigger a model-to-model transformation based on a trace model and a view model
  # (source models, XMI) which returns an interaction model (target model, XMI) that reflects 
  # inter-object interactions
  :public method createInteractionModel { viewModel traceModel targetModel } {
    # trigger qvto model transformation
    #cd [pwd]/ks_modelBuilder
    :viewModel set $viewModel
    :traceModel set $traceModel    

    puts path:[pwd]
    set workingDir [lrange [file split [pwd]] end end]

    #if {$workingDir eq "ks_modelBuilder"} {
      #puts path:[pwd]

      #cd ..
      puts [exec java -jar [:qvtoStandAlone get] -xform [:interObjectTransformer get] -src [:viewMMEcore get] $viewModel [:traceMMEcore get] $traceModel -tgt [:umlMMEcore get] $targetModel]
      #cd ks_modelBuilder

    #} elseif {$workingDir eq "ks-tests-ordered"} {
      #puts path:[pwd]
      
      #puts [exec java -jar [:qvtoStandAlone get] -xform [:interObjectTransformer get] -src [:viewMMEcore get] $viewModel [:traceMMEcore get] $traceModel -tgt [:umlMMEcore get] $targetModel]

    #} else { puts "PATH_ERROR: unexpected path: [pwd]" }


    
		#cd ..    
		return 1
  }

  # trigger a model-to-model transformation based on a trace model and a view model
  # (source models, XMI) which returns an interaction model (target model, XMI) that reflects 
  # interactions between architectural system component
  :public method createInterComponentInteractionModel { viewModel traceModel } {
    # trigger qvto model transformation
    #puts [exec java -jar qvto-app-0.1-SNAPSHOT.jar -xform TracePart2UML.qvto -src VIEW.ecore $viewModel EXTTRACE.ecore $traceModel -tgt UML.ecore $targetModel]
    return 1
  }

}

}


#[::MB::ModelBuilder new] createInteractionModel vStack1.xmi tmStackTests.xmi im.xmi
#[::MB::ModelBuilder new] createInterComponentInteractionModel view2.xmi traceModel1.xmi im.xmi
